#include "halflife.h"
#include <stdio.h>
#include <sys/wait.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

char *HLIT_GetVersion(void)
{
  return HLIT_VERSION;
}

char *HLIT_GetCopyright(void)
{
  return HLIT_COPYRIGHT;
}
// fonction de demande en broadcast des info de la partie
int HLI_RequestInfo(PServerInfo SI) {
   unsigned char Buf[9];
   
   Buf[0] = 255; Buf[1] = 255; Buf[2] = 255; Buf[3] = 255;
   strcpy(Buf+4,"info");
   return UDPSendBroadcast(SI,Buf,8,HLSERVERPORT);
}
// fonction de demande en broadcast des info sur les joueurs
int HLI_RequestPlayers(PServerInfo SI) {
   unsigned char Buf[12];
   
   Buf[0] = 255; Buf[1] = 255; Buf[2] = 255; Buf[3] = 255;
   strcpy(Buf+4,"players");
   return UDPSendBroadcast(SI,Buf,11,HLSERVERPORT);
}
// fonction de demande unicast des 
int HLI_RequestInfo_Unicast(PServerInfo SI,char * Colysee) {
   unsigned char Buf[9];
   strcpy(Buf,REQINFO);
   return UDPSendToAddr(SI,Buf,9,Colysee,PORTBOUNCE);
}
// fonction de demande unicast des
int HLI_RequestPlayers_Unicast(PServerInfo SI,char * Colysee) {
// mmmmh XXX
   unsigned char Buf[12];
   strcpy(Buf,REQPLAYERS);
   return UDPSendToAddr(SI,Buf,12,Colysee,PORTBOUNCE);
}


void HLI_FillInfos(char *Message,PHLInfo HL)
{
  int pos;
  
  pos = 5;
  strncpy(HL->Server,Message+pos,sizeof(HL->Server));
  pos += strlen(Message+pos)+1;
  strncpy(HL->Nick,Message+pos,sizeof(HL->Nick));
  pos += strlen(Message+pos)+1;
  strncpy(HL->Map,Message+pos,sizeof(HL->Map));
  pos += strlen(Message+pos)+1;
  pos += strlen(Message+pos)+1;
  strncpy(HL->GameType,Message+pos,sizeof(HL->GameType));
  pos += strlen(Message+pos)+1;
  HL->NbPlayers = Message[pos];
  HL->Max = Message[pos+1];
}

void HLI_FillPlayers(char *Message,PHLPlayers HL)
{
  int pos,len,i;
  
//time_t t;

  pos = 5;
  HL->NbPlayers = (int)Message[pos++];
  HL->Frags = (char *)malloc(HL->NbPlayers*sizeof(unsigned char));
  HL->Players = (char **)malloc(HL->NbPlayers*sizeof(char *));
  
  for(i=0;i<HL->NbPlayers;i++)
  {
    pos++; // On zap le numero du joueur
    len = strlen(Message+pos)+1;
    HL->Players[i] = (char *)malloc(len);
    strncpy(HL->Players[i],Message+pos,len);
    pos += len;
    HL->Frags[i] = Message[pos];
/*    t = (time_t)Message[pos+4];
    printf("%d %d %d %d %d %d %c\n",Message[pos+1],Message[pos+2],Message[pos+3],Message[pos+4],Message[pos+5],Message[pos+6],Message[pos+7]);*/
    pos += 8; // On zap les infos inconnues
  }
}

void *HLI_FillInformations(char *RemoteHost,unsigned char *Message,int *Type)
{
  PHLInfo HLInfo = NULL;
  PHLPlayers HLPlayers = NULL;
  int len;

  len = strlen(Message);
  *Type = HL_NOTHING;
  if( (Message[0] == 255) && (Message[1] == 255) && (Message[2] == 255) && (Message[3] == 255))
  {
    if(Message[4] == 'C')
    {
      HLInfo = (PHLInfo) malloc(sizeof(THLInfo));
      *Type = HL_INFOS;
      strncpy(HLInfo->From,RemoteHost,sizeof(HLInfo->From));
      HLI_FillInfos(Message,HLInfo);
      return (void *) HLInfo;
    }
    else if(Message[4] == 'D')
    {
      HLPlayers = (PHLPlayers) malloc(sizeof(THLPlayers));
      *Type = HL_PLAYERS;
      strncpy(HLPlayers->From,RemoteHost,sizeof(HLPlayers->From));
      HLI_FillPlayers(Message,HLPlayers);
      return (void *) HLPlayers;
    }
  }
  return NULL;
}

void HLI_FreeInfos(int Type,void *Infos)
{
  PHLInfo HLI;
  PHLPlayers HLP;
  int i;
  
  if(Type == HL_INFOS)
  {
    HLI = (PHLInfo) Infos;
    free(HLI);
  }
  else if(Type == HL_PLAYERS)
  {
    HLP = (PHLPlayers) Infos;
    for(i=0;i<HLP->NbPlayers;i++)
      free(HLP->Players[i]);
    free(HLP->Players);
    free(HLP->Frags);
    free(HLP);
  }
}
