/*
*
*	Structures de la memoire et prototypes de fonctions associees.
*
*
*
*
*
*
*
*
*/
#ifndef MEM_H
#define MEM_H

#include "halflife.h"

/* pour la memoire partagee */
#include <sys/types.h>
#include <sys/shm.h>
#include <unistd.h>

#define SHM_ERROR 	-1
// 	rw- --- ---
#define DROITS 		384
#define SHMFLAGS	0

// pour identifier le serveur
typedef struct {
	int id;
	struct in_addr sin_addr;
} ID_Serveur;


// structure des cellules de serveur dans la file 
typedef struct CellServeur {
	int shmid;
	struct CellServeur * Prec;
	int Prec_shmid;
	struct CellServeur * Suiv;
	int Suiv_shmid;
	unsigned int nbclientvu;
	unsigned char * Msg;
	int len;
	int Msg_shmid;
	time_t Date;
	ID_Serveur id;
} File_Serveur, * P_File_Serveur;

// La base de la memoire pour le tunnel
typedef struct  {
	struct CellServeur * File;
	int shmid_File;
	unsigned short NbServeur;	
	// Socket pour ecouter les demandes aux serveur
	// et repondre aux clients
	PServerInfo SI_HLserveur;
	pid_t SI_HLserveur_pid;
	// Socket pour gerer le tunnel
	PServerInfo SIT;
	pid_t SIT_pid;
	// Socket pour ecouter les reponses des serveurs
	PServerInfo SI_HLclient;
	pid_t SI_HLclient_pid;		
	
} Basemem , * P_Basemem;

/* Fonction d'utilisation SHM */
extern P_File_Serveur Enfiler( P_File_Serveur  Pt_File , unsigned char * Msg,int len );
extern P_File_Serveur Cell_Suiv(P_File_Serveur Pt_File);
extern P_File_Serveur Attacher_File(P_Basemem Pt_Mmem);
//extern P_File_Serveur Attacher_FileLocal(P_Basemem Pt_Mmem);
extern unsigned char * Attacher_Msg(P_File_Serveur Pt_File);
extern int Detacher_shm(unsigned char * Pt );
extern void Free_Allshm(P_File_Serveur Pt_Queue_File);
int Get_Bmem() ;
P_Basemem Attacher_Bmem(int monshmid) ;


#endif
