/****************************************************************/
/* Socket unit header - TCP/UDP                                 */
/* (c) Christophe CALMEJANE (Ze KiLleR) - 1999                  */
/****************************************************************/
#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include <arpa/inet.h>
#include <netdb.h>

#define SOCKET_ERROR -1

typedef struct {
  int sock;
  struct sockaddr_in SAddr;
} ServerInfo, *PServerInfo;

typedef struct {
  int sock;
  struct sockaddr SAddr;
} ClientSocket, *PClientSocket;


char * GetMachineName(char *RemoteHost);
char *NameOfPort(char *Host);

PServerInfo CreateServer(int port,int type);
int ServerListen(PServerInfo SI);
PClientSocket ServerAcceptConnection(PServerInfo SI);
void ServerDisconnect(PServerInfo SI);
PClientSocket ClientConnect(char *adrs,char *port);
int ClientSend(PClientSocket CS,char *msg); // -1 si erreur
int UDPSendBroadcast(PServerInfo SI,char *Text,int len,char *port); // -1 si erreur
int UDPSendToAddr(PServerInfo SI,char *Text,int len,char *Addr,char *port); // -1 si erreur
int UDPReceiveFrom(PServerInfo SI,char *Text,int len,char **ip,int Blocking);
int SetSocketOptions(int sock,int Level,int Opt); // -1 si erreur

